package plotter;

import java.awt.Color;
import java.awt.Graphics;

import javax.swing.JPanel;

import expr.ChartData;
import expr.Expression;

@SuppressWarnings("serial")
public class Plot extends JPanel {
	private ChartData cd;

	Plot( ChartData cd ) {
		this.cd = cd ;
		setBackground( new Color(200, 200, 255) );
	}
	
	@Override public void paintComponent( Graphics g) {
		int width = this.getWidth() ;
		int height = this.getHeight() ;
		g.clearRect(0, 0, width, height);
		Expression e = cd.getExpression() ;
		double xMin = cd.getXMin() ;
		double xScale = (cd.getXMax() - cd.getXMin()) / (width-1) ;
		double yMin = cd.getYMin() ;
		double yScale = (height-1) / (cd.getYMax() - cd.getYMin()) ;
		for( int i=1 ; i < width ; ++i) {
			double x =  xMin + xScale * i ;
			double y = e.value( x ) ;
			int j = (height-1) - (int)( (y-yMin) * yScale ) ;
			g.drawRect(i, j, 1, 1);
		}
		int x0 = (int)( (0-xMin) / xScale )  ;
		g.drawLine(x0, 0, x0, height);
		int y0 = (height-1) - (int)( (0-yMin) * yScale ) ;
		g.drawLine(0, y0, width, y0);
	}
}
